<template>
  <div
    data-component-group="auth-form"
    data-component="forgot-pass"
  >
    <Form
      :title="$t('views.reset.title')"
      :second-title="$t('views.reset.second_title')"
      :subtitle="$t('views.reset.subtitle')"
    >
      <v-text-field
        v-model="email"
        prepend-inner-icon="mail"
        :label="$t('components.forms.register.email_placeholder')"
        required
        type="text"
        :autofocus="true"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />

      <div class="form-actions">
        <v-btn
          flat
          class="trigger"
          :loading="isLoading"
          @click="submit"
        >
          {{ $t('components.forms.reset.submit') }}
        </v-btn>
      </div>
    </Form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form.vue';

  export default {
    components: {
      Form,
    },
    mixins: [validationMixin],
    validations: {
      email: {
        required,
        email
      },
    },
    data: () => ({
      email: '',
      isLoading: false,
      isSubmitted: false,
      colors,
    }),
    computed: {
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push('E-mail is required');
        }
        if (!this.$v.email.email) {
          errors.push('Must be valid e-mail');
        }
        return errors;
      },
    },
    created() {
      this.$store.watch(() => {
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        if (this.isSubmitted && hasErrors) {
          this.isSubmitted = false;
          this.isLoading = false;
        }
      }, () => {});
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.pending || this.$v.invalid) {
          return false;
        }

        return this.sendPassResetRequest();
      },
      clear() {
        this.$v.$reset();
        this.email = '';
        this.isSubmitted = false;
      },
      canSubmitRequest() {
        return this.email !== '';
      },
      sendPassResetRequest() {
        this.isLoading = true;
        this.isSubmitted = true;
        return this.$store.dispatch('auth/sendPassResetRequest', this.email);
      }
    },
  };
</script>
